///////////////////////////////////////////////////////////////////////////////
//
//  LEDDISP.CH
//
//  Contents  :
//    Constants for the LED display and the calculator
//
//  Remarks:
//    This software is published under the GNU General Public License (GPL)
//  
//      http://www.opensource.org/licenses/gpl-license.php
//  
//    NO WARRANTY
//  
//    BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
//    FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT
//    WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER
//    PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, 
//    EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE 
//    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
//    PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE 
//    PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME 
//    THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
//  
//    IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
//    WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR 
//    REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
//    DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
//    DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
//    (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
//    INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
//    OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH 
//    HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF 
//    SUCH DAMAGES.
//  
//
//  Author and copyright
//    (c) Hannes Ziegler 2005
//
//        www.knowleXbase.com
//
///////////////////////////////////////////////////////////////////////////////


#ifndef _LEDDISP_CH

#define _LEDDISP_CH

#define  BMP_BACKGROUND         1000 

#define  BMP_BTN_0              1001 
#define  BMP_BTN_1              1002 
#define  BMP_BTN_2              1003 
#define  BMP_BTN_3              1004 
#define  BMP_BTN_4              1005 
#define  BMP_BTN_5              1006 
#define  BMP_BTN_6              1007 
#define  BMP_BTN_7              1008 
#define  BMP_BTN_8              1009 
#define  BMP_BTN_9              1010 
#define  BMP_BTN_DOT            1011 
#define  BMP_BTN_SIGN           1012 

#define  BMP_BTN_CLEAR          1021 
#define  BMP_BTN_CLEARENTRY     1022 
#define  BMP_BTN_BACKSPACE      1023 
#define  BMP_BTN_EQUAL          1024 

#define  BMP_BTN_DIVIDE         1031 
#define  BMP_BTN_MULTIPLY       1032 
#define  BMP_BTN_MINUS          1033 
#define  BMP_BTN_PLUS           1034 

#define  BMP_BTN_POWER2         1041 
#define  BMP_BTN_POWERY         1042 
#define  BMP_BTN_ONEDIVX        1043 
#define  BMP_BTN_ROOT           1044 

#define  BMP_BTN_MEM_STORE      1051 
#define  BMP_BTN_MEM_PLUS       1052 
#define  BMP_BTN_MEM_RECALL     1053 
#define  BMP_BTN_MEM_CLEAR      1054 

#define  BMP_BTN_EPOWERX        1061 
#define  BMP_BTN_LOGN           1062 
#define  BMP_BTN_LOG10          1063 
#define  BMP_BTN_10POWERX       1064 

#define  BMP_LED_0              1101 
#define  BMP_LED_1              1102 
#define  BMP_LED_2              1103 
#define  BMP_LED_3              1104 
#define  BMP_LED_4              1105 
#define  BMP_LED_5              1106 
#define  BMP_LED_6              1107 
#define  BMP_LED_7              1108 
#define  BMP_LED_8              1109 
#define  BMP_LED_9              1110 
#define  BMP_LED_BLANK          1111
#define  BMP_LED_NEG            1112
#define  BMP_LED_DOT            1113

#define  BMP_LED_S0             1200 
#define  BMP_LED_S1             1201 
#define  BMP_LED_S2             1202 
#define  BMP_LED_S3             1203 
#define  BMP_LED_S4             1204 
#define  BMP_LED_S5             1205 
#define  BMP_LED_S6             1206 
#define  BMP_LED_S7             1207 
#define  BMP_LED_S8             1208 
#define  BMP_LED_S9             1209 
#define  BMP_LED_SBLANK         1210 
#define  BMP_LED_SNEG           1211 

#define  BMP_LED_A              1300 
#define  BMP_LED_B              1301 
#define  BMP_LED_C              1302 
#define  BMP_LED_D              1303 
#define  BMP_LED_E              1304 
#define  BMP_LED_F              1305 
#define  BMP_LED_O              1306 
#define  BMP_LED_R              1307

#endif
