/***********************************
*     PROJECT :Classified          
*        FILE :CLComboBrowse.prg
*  Programmer :James Loughner
*  Created    :03/09/05
*  
*  For MerrimacBrowse CLCOMB database
*************************************/
 
#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "Appbrow.ch" 
#include "Dmlb.ch" 
#include "dll.ch"
#include "inkey.ch"

#define MAXCOMB  35

STATIC oPub

CLASS CombinationBrowse FROM BasicBrowse
   EXPORTED:
      METHOD Create,SetPubs,destroy,Init
      VAR DBArea,DBComb,UpdateObj,PrevOrd,CARD

ENDCLASS

METHOD CombinationBrowse:Init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::_BasicBrowse:Init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::DBArea := ""   // this is the XXCRD file
   ::DBComb := ""   // this is the XXCOMB file
RETURN Self

METHOD CombinationBrowse:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
LOCAL I,bCol,o:=Self,HelpPrefix:="CombinationBrowse-" ,LenComb ,cPub
   ::BGColor := ::CtrlMaster:BGColor
   oPub:=::CtrlMaster:oPub // must be private from calling function for visability in the code block
   * Execute method of the super class
   ::_BasicBrowse:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::SetTitle("Select Combination Code")
   IF LEFT(::DBArea,2) = "CL"
      LenComb := 2
   ELSE 
      LenComb := 3
   ENDIF   
   ::PrevOrd := (::DBarea)->(OrdSetFocus("CARDCOMB"))
   (::DBArea)->(DBSetScope(SCOPE_BOTH,::CARD)) 
   (::DBArea)->(DBSetRelation(::DBComb,{||::CtrlMaster:oPub:CurrentPub+STR((::DBArea)->COMB,LenComb)}))
   aPP := {{XBP_PP_HILITE_FGCLR, GRA_CLR_BLACK},{XBP_PP_HILITE_BGCLR, GRA_CLR_YELLOW}}
   ::oBrowse := JimsBrowse():New(::BrowseBox,,{0,0},::BrowseBox:CurrentSize(),aPP)
   ::oBrowse:CursorMode := XBPBRW_CURSOR_ROW
   ::oBrowse:DBArea := ::DBArea    // this is the XXCRD
   ::oBrowse:addColumn( {||(::DBArea)->COMB},4, "Code" )
   FOR I = 1 TO MAXCOMB
      IF (::DBComb)->(FieldPos("PUB"+ALLTRIM(STR(I))))!=0
         // codeblock to show the member names      
         bCol := &("{||"+::DBComb+"->(STR(FieldGet(FieldPos('PCT'+'"+ALLTRIM(STR(I))+"')),5,1)+'% '+ShowPubName(FieldGet(FieldPos('PUB'+'"+ALLTRIM(STR(I))+"'))))}")
         ::oBrowse:addColumn( bCol,18, "Publication"+ALLTRIM(STR(I)) )
      ENDIF   
   NEXT I   
   ::oBrowse:ItemSelected := {|| ::SetPubs(),::Destroy()}
   ::oBrowse:Create()  
   ::oBrowse:SetColorBG(::BGColor)
   ::oBrowse:SetColorFG(GRA_CLR_RED)
   FOR I = 1 TO ::oBrowse:colCount
      ::oBrowse:GetColumn(I):Heading:SetColorBG(::BGColor)
   NEXT I
   ::oBrowse:RefreshAll()  

//   ::oBrowse:helpLink := MagicHelpLabel():New(660,HelpPrefix+"Browse")   
   * Display the form
   ::show()
   SetAppFocus(::oBrowse)
   IF (::DBComb)->(EOF().AND.BOF())
      MPMMSGBOX("Error-No Combination defined in "+::DBComb,"ERROR")
      ::Destroy() 
   ENDIF
RETURN self

METHOD CombinationBrowse:SetPubs()
LOCAL I,cPubs := ""
   IF !EMPTY(::UpdateObj)
      cPubs := SetCombPubs(::DBComb)
      ::UpdateObj:SetData(cPubs)
   ENDIF
RETURN Self

METHOD CombinationBrowse:Destroy()
   (::DBArea)->(DBClearScope())
   (::DBArea)->(DBClearFilter()) 
   (::DBArea)->(OrdSetFocus(::PrevOrd))

   ::BasicBrowse:Destroy()
RETURN Self

FUNCTION SetCombPubs(DBArea)
LOCAL I,cRtn := ""
   FOR I = 1 TO MAXCOMB
      IF (DBArea)->(FieldPos("PUB"+ALLTRIM(STR(I))))!=0         
         cRtn += ALLTRIM((DBArea)->(FieldGet(FieldPos('PUB'+ALLTRIM(STR(I))))))
      ENDIF   
   NEXT I   
RETURN cRtn


FUNCTION ShowPubName(cPub)
LOCAL cRtn:="" 
    IF !EMPTY(cPub).AND.!EMPTY(oPub)
       cRtn := oPub:GetValue(cPub,"PUBNAME")
    ENDIF    
RETURN cRtn