/***********************************
*     PROJECT :Files              
*        FILE :Files.prg
*  Programmer :James Loughner
*  Created    :08/10/04
*  
*  Open create file functions
*************************************/
 
#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "Appbrow.ch" 
#include "Dmlb.ch" 
#include "dll.ch"
#include "inkey.ch"
#include "Fileio.CH"

#xtrans  CenterPos( <aSize>, <aRefSize> ) => ;
         { Int( (<aRefSize>\[1] - <aSize>\[1]) / 2 ) ;
         , Int( (<aRefSize>\[2] - <aSize>\[2]) / 2 ) }

FUNCTION FixStruct(aFix)
LOCAL cDB,aDef,aIndex,I,J
LOCAL oDlg,oStatic,a_Size := {300,100}
   oDlg:=XbpDialog():New(SetAppWindow():DrawingArea,,CenterPos(a_Size,SetAppWindow():CurrentSize()),a_Size)
   oDlg:border := XBPDLG_NO_BORDER
   oDlg:TitleBar := .F.
   oDlg:Create()     
   oStatic := XbpStatic():New(oDlg:drawingArea,,{0,0},a_Size)
   oStatic:Options := XBPSTATIC_TEXT_CENTER+XBPSTATIC_TEXT_VCENTER
   oStatic:Type := XBPSTATIC_TYPE_TEXT
   oStatic:Create()
   BusyPointer(SetAppWindow(),.T.)
   FOR J = 1 TO LEN(aFix)
      cDB    := aFix[J,1]
      aDef   := aFix[J,2]
      aIndex := aFix[J,3]
      oStatic:SetCaption("Updating structures..."+cDB)

      IF FILE("data\"+cDB+".DBF")
         FERASE("data\$temp.dbf")
         FERASE("data\$temp.dbt")
         IF FRename("data\"+cDB+".DBF","data\$temp.dbf") = 0
            IF FILE("data\"+cDB+".DBT") // if a memo file rename it too
               IF FRename("data\"+cDB+".DBT","data\$temp.dbt") != 0
                  MsgBox("ERROR-FIXING MEMO for "+cDB+" error "+STR(FError()))
                  QUIT
               ENDIF
            ENDIF
            Sleep(10)
            DBCreate("data\"+cDB,aDef) // create new struct
            IF IndexExt() = ".CDX"
               IF !EMPTY(aIndex) .AND. FILE(aIndex[1,1]+ IndexExt())
                  IF Ferase("data\"+aIndex[1,1]+ IndexExt()) != 0
                     MsgBox("ERROR-could not erase "+aIndex[1,1]+IndexExt()+" Error "+STR(FError()))
                  ENDIF
               ENDIF
            ELSE
               FOR I= 1 TO LEN(aIndex) // erase the index(s)
                  IF FILE("data\"+aIndex[I,1]+ IndexExt())
                     IF Ferase("data\"+aIndex[I,1]+ IndexExt()) != 0
                        MsgBox("ERROR-could not erase "+aIndex[I,1]+IndexExt()+" Error "+STR(FError()))
                     ENDIF
                  ENDIF
               NEXT
            ENDIF
            DbfNtxUse("data\"+cDB,aIndex) // use it
            APPEND FROM data\$temp.dbf  // get records from old file
            IF Ferase("data\$temp.dbf")!= 0 // erase temp file
               MsgBox("ERROR-could not erase $temp.dbf Error "+STR(FError()))
               QUIT
            ENDIF
            IF FILE("data\$temp.dbt") // if a memo file rename it too
               IF Ferase("data\$temp.dbt")!= 0 // erase temp file
                  MsgBox("ERROR-could not erase $temp.dbt Error "+STR(FError()))
                  QUIT
               ENDIF
            ENDIF
            USE // close it
         ELSE
            MsgBox("ERROR-FIXING STRUCTURE "+cDB+" error "+STR(FError()))
            QUIT
         ENDIF
      ENDIF
   NEXT  
   BusyPointer(SetAppWindow(),.F.)
   oDlg:destroy()
RETURN NIL


PROCEDURE DbfNtxUse( cDbfFile, aIndexFiles )
LOCAL n, nMax, I
LOCAL cIndexFile, cIndexName, cIndexKey, bIndexblock,oArea ,lDescend := .F.,lUnique := .F.
LOCAL oDlg,oStatic,a_Size := {350,100}
PRIVATE oProgress

   DO WHILE .T.
      USE (cDbfFile) NEW                // Open a DBF-file
      IF NetErr()
         IF oDlg = NIL
            oDlg:=XbpDialog():New(SetAppWindow():DrawingArea,,CenterPos(a_Size,SetAppWindow():CurrentSize()),a_Size)
            oDlg:border := XBPDLG_NO_BORDER
            oDlg:TitleBar := .F.
            oDlg:Create()     
            oStatic := XbpStatic():New(oDlg:drawingArea,,{0,0},a_Size)
            oStatic:Options := XBPSTATIC_TEXT_CENTER+XBPSTATIC_TEXT_VCENTER
            oStatic:Type := XBPSTATIC_TYPE_TEXT
            oStatic:Create()
            oStatic:SetCaption("File Locked Waiting to Open..."+cDbfFile)
            BusyPointer(SetAppWindow(),.T.)
         ENDIF
         SLEEP(200)   
      ELSE
         IF !EMPTY(oDlg) 
            BusyPointer(SetAppWindow(),.F.)
            oDlg:destroy()
            oDlg := NIL
         ENDIF   
         EXIT   
      ENDIF
   ENDDO

   n    := 1
   nMax := Len( aIndexFiles )
   IF oMainWindow != SetAppWindow()   // make sure SetAppWindow points to the main window  oMinWindow is Public
      SetAppWindow(oMainWindow)
   ENDIF   
   IF SetAppWindow():IsDerivedFrom("XbpCRT")
      oArea := SetAppWindow() 
   ELSE 
      oArea := ParentDialog(SetAppWindow()):DrawingArea 
   ENDIF  

   DO WHILE n <= nMax
      // Save index data
      lDescend   := .F. 
      lUnique    := .F.
      cIndexFile := IF(IndexExt() = ".CDX",cDbfFile,aIndexFiles[n,1])
      cIndexName := aIndexFiles[n,2]
      cIndexKey  := aIndexFiles[n,3]
      IF LEN(aIndexFiles[n]) >=4 
         lDescend  := aIndexFiles[n,4]
         IF LEN(aIndexFiles[n]) >=5
           lUnique := aIndexFiles[n,5]
         ENDIF  
      ENDIF   
      IF !FILE(cIndexFile+IndexExt())    // Attempt to open an index file
                                  // Create index!

         DO WHILE .T.
            USE (cDbfFile) EXCLUSIVE // Open DBF exclusively
            IF NetErr()
               IF oDlg = NIL
                  oDlg:=XbpDialog():New(SetAppWindow():DrawingArea,,CenterPos(a_Size,SetAppWindow():CurrentSize()),a_Size)
                  oDlg:border := XBPDLG_NO_BORDER
                  oDlg:TitleBar := .F.
                  oDlg:Create()     
                  oStatic := XbpStatic():New(oDlg:drawingArea,,{0,0},a_Size)
                  oStatic:Options := XBPSTATIC_TEXT_CENTER+XBPSTATIC_TEXT_VCENTER
                  oStatic:Type := XBPSTATIC_TYPE_TEXT
                  oStatic:Create()
                  oStatic:SetCaption("File in Use Waiting to Open..."+cDbfFile)
                  BusyPointer(SetAppWindow(),.T.)
               ENDIF
               SLEEP(200)   
            ELSE
               IF !EMPTY(oDlg) 
                  BusyPointer(SetAppWindow(),.F.)
                  oDlg:destroy()
                  oDlg := NIL
               ENDIF   
               EXIT   
            ENDIF
         ENDDO
         
         IF IndexExt() = ".NTX"
            IF lDescend 
               OrdCondSet(,,,,,,,,,,.T.) 
            ENDIF
            oProgress := StartProgress(oArea,{400,60},1,Lastrec(),,"Indexing "+cIndexFile) //ProgressBar():New(SetAppWindow():DrawingArea,, CenterPos({400,24},SetAppWindow():CurrentSize() ), {400,24},, .F. )
            bIndexBlock := &("{|| IncProgress(oProgress), "+cIndexKey+"}" )
            OrdCreate(cIndexFile,cIndexName,cIndexKey,bIndexBlock,lUnique)
         ELSE  // if CDX add all orders to first IndexFile
            oProgress := StartProgress(oArea,{400,60},1,Lastrec(),,"Indexing "+cIndexFile) //ProgressBar():New(SetAppWindow():DrawingArea,, CenterPos({400,24},SetAppWindow():CurrentSize() ), {400,24},, .F. )
            I := 1
            DO WHILE I <= nMax
               lDescend   := .F.
               cIndexName := aIndexFiles[I,2]
               cIndexKey  := aIndexFiles[I,3]
               IF LEN(aIndexFiles[I]) >=4 
                  OrdCondSet(,,,,,,,,,,aIndexFiles[I,4]) 
               ENDIF   
               IF LEN(aIndexFiles[I]) >=5
                 lUnique := aIndexFiles[I,5]
               ELSE
                 lUnique := .F.
               ENDIF  
               SetAppWindow():Disable()
               BusyPointer(SetAppWindow(),.T.)  
               bIndexBlock := &("{|| IncProgress(oProgress), "+cIndexKey+"}" ) 
               OrdCreate(cIndexFile,cIndexName,cIndexKey,bIndexBlock,lUnique)
               oProgress:ProgressBar:Current := 0
               SetAppWindow():Enable()
               BusyPointer(SetAppWindow(),.F.)  
               ++I 
            ENDDO
         ENDIF


         USE (cDbfFile)           // Open SHARED without
                                  // index files
         n := 1  
//         SLEEP(100)                 // Open files again
         oProgress:Destroy()
         LOOP                     // Back to BEGIN SEQUENCE
      ELSE
         OrdListAdd(cIndexFile)
         IF IndexExt() = ".CDX"   // only need to open it once
            n := nMax   //EXIT
         ENDIF
      ENDIF
      IF n == nMax 
         IF !BagsOK(aIndexFiles,cDbfFile)
            n := 0
         ENDIF
      ENDIF
      n++
   ENDDO

RETURN


FUNCTION BagsOK(aIndexFiles,cDbf)
LOCAL lRtn := .T.,n,cBag,nRes,I,aTaged:={},Tmp 
   Tmp := SET(_SET_EXACT,.T.)
   DO CASE
      CASE IndexExt() = ".NTX"
        FOR I = 1 TO LEN(aIndexFiles)
           cBag := UPPER(aIndexFiles[I,2])
           nRes := Ascan(OrdList(),cBag)
           IF nRes = 0  // Bag not in list
              AADD(aTaged,aIndexFiles[I,1]+IndexExt()) //Tag for deletion
              lRtn := .F.
           ELSE
              IF !(UPPER(aIndexFiles[I,3]) == UPPER(OrdKey(nRes))) // Index expression does not match
                  AADD(aTaged,aIndexFiles[I,1]+IndexExt()) //Tag for deletion
                 lRtn := .F.
              ENDIF
           ENDIF
        NEXT I   
      CASE IndexExt() = ".CDX"
        FOR I = 1 TO LEN(aIndexFiles)
           cBag := UPPER(aIndexFiles[I,2])
           nRes := Ascan(OrdList(),cBag)
           IF LEN(OrdList()) != LEN(aIndexFiles)
              AADD(aTaged,cDbf+IndexExt()) //Tag for deletion
              lRtn := .F. 
              EXIT
           ENDIF
           IF nRes = 0  // Bag not in list
              AADD(aTaged,cDbf+IndexExt()) //Tag for deletion
              lRtn := .F. 
              EXIT
           ELSE
              IF !(UPPER(aIndexFiles[I,3]) == UPPER(OrdKey(nRes))) // Index expression does not match
                  AADD(aTaged,cDbf+IndexExt()) //Tag for deletion
                 lRtn := .F.
                 EXIT
              ENDIF
           ENDIF
        NEXT I 
   ENDCASE 
   SET(_SET_EXACT,Tmp)  
   IF LEN(aTaged) > 0     
      OrdListClear()
      FOR I = 1 TO LEN(aTaged)
         FERASE(aTaged[I])
      NEXT I
   ENDIF
     
RETURN lRtn

FUNCTION IsADir(cPath,lCreate)
LOCAL lRtn:=.F.,nHndl,nButton
   cPath := AllTRIM(cPath)
   cPath := IF(RIGHT(cPath,1)!="\",Cpath+"\",Cpath)
   IF (nHndl:=FCREATE(cPath+"XYXYXY.TXT"))=-1
      IF lCreate
         nButton := MPMConfirmBox(,"Dir "+cPath+" does not exist."+CHR(13)+" Create?","New Dir?",XBPMB_YESNO,XBPMB_QUESTION )
         IF nButton = XBPMB_RET_YES
            IF !tdMakeDir(cPath)
               msgBox("ERROR- Directory not created!")
            ELSE
               lRtn := .T.
            ENDIF
         ENDIF
      ENDIF
   ELSE
      FClose(nHndl)
      FERASE(cPath+"XYXYXY.TXT")
      lRtn := .T.
   ENDIF
RETURN lRtn

FUNCTION tdMakeDir(cPathDir) // thanks to Clayton Jones
LOCAL lRetval := .F.
LOCAL nResult := 0
LOCAL nHandle

******* load dll
nHandle := dllLoad('kernel32.dll')

IF nHandle != 0
   ******* Call the API function
   nResult :=  dllCall(nHandle,;
        DLL_STDCALL,'CreateDirectoryA',cPathdir,0)

   ******* Release dll
   dllUnLoad(nHandle)

   ******* test result, set retval
   IF nResult != 0
      lRetval := .T.
   ENDIF
ENDIF

RETURN lRetval

PROCEDURE ClearRecord(cField,xVal)
LOCAL I,PrvScope,NextRec,nRec
   nRec := RecNo()
   PrevScope := DBScope(SCOPE_BOTH)
   DBClearScope()
   DBSkip()
   NextRec := RecNo()
   DBSkip(-1)
   IF LockRec()
      FOR I = 1 TO FCount()
         DO CASE
            CASE DBStruct()[I,2] = "C"
               FieldPut(I,"")
            CASE DBStruct()[I,2] = "L"
               FieldPut(I,.F.)
            CASE DBStruct()[I,2] = "N"
               FieldPut(I,0)
            CASE DBStruct()[I,2] = "D"
               FieldPut(I,CTOD(""))
            CASE DBStruct()[I,2] = "M"
               FieldPut(I,"")
         ENDCASE
      NEXT I    
      IF !EMPTY(cField).AND. !EMPTY(xVal)
         FieldPut(FieldPos(cField),xVal)
      ENDIF
      DBDelete()
      DBRUnLock(nRec)
   ENDIF
   IF PrevScope[1] != NIL
      DBSetScope(SCOPE_TOP,PrevScope[1])
   ENDIF
   IF PrevScope[2] != NIL
      DBSetScope(SCOPE_BOTTOM,PrevScope[2])
   ENDIF
   DBGoTo(NextRec)
RETURN 

FUNCTION ClearAllRecords(cField,xVal)
LOCAL nRec := 0
   DO WHILE !EOF()
      ClearRecord(cField,xVal)
      IF DBScope()
         DBGoTop()
      ELSE   
         DBSkip()
      ENDIF    
      ++nRec
   ENDDO
RETURN nRec

FUNCTION CloneRecord(cTarget)       // create a new resord the same as the current record (leave locked) and pointer on it
LOCAL nRec := 0,I,aData:={},aField:={}         // traget is the target area must have the same structure as origianl
   IF cTarget = NIL
      cTarget := ALIAS()
   ENDIF   
   FOR I = 1 TO FCount()
      AADD(aData,FieldGet(I))
      AADD(aField,FieldName(I))
   NEXT I 
   (cTarget)->(AppendRec())
   FOR I = 1 TO FCount()
      (cTarget)->(FieldPut(FieldPos(aField[I]),aData[I]))
   NEXT I
RETURN nRec

FUNCTION AddRecord(DelKey,cIndex)       // used to reuse deleted records DelKey is the key to find indicating a deleted record
LOCAL lRtn := .F.
   IF !DBScope()
      Set Deleted OFF
      IF !DBSeek(DelKey,,cIndex)
         AppendRec()
         lRtn := .T.
      ELSE 
         lRtn := LockRec()   // reuse records
         IF lRtn
            DBRecall()
         ENDIF      
      ENDIF   
      Set Deleted ON
   ELSE
     msgBox("Program error Scope set in AddRecord")
   ENDIF
RETURN lRtn

PROCEDURE Set_Dir(oSelField,oOwner,lShowFiles)
LOCAL aSize,aPos,oDlg,DrawingArea,oDirs,oSel,ofield
   aSize := {300,360}
   aPos  := CenterPos( aSize, AppDesktop():currentSize() )

   oDlg := XbpDialog():New(SetAppWindow():DrawingArea,oOwner, aPos, aSize, , .T. )
//   oDlg:taskList := .T.
   oDlg:maxButton := .F.
   oDlg:border   := XBPDLG_DLGBORDER
   oDlg:title    := "Select Directory"
   oDlg:close    := {|| oDlg:Destroy()}
   oDlg:create()

   drawingArea := oDlg:drawingArea
   drawingArea:setFontCompoundName( FONT_HELV_SMALL )

   // create file tree
   oDirs  := DirSelector():new ( drawingArea, , {5 ,64}, {290,250} )
   oDirs:tabStop := .T.
   oDirs:StartDir := CurDrive()+":\"+CurDir()  // directory to show on startup
   oDirs:ShowFiles := lShowFiles  // set to .F. to show and select only directories
   oDirs:create()

   oSel := XbpPushButton():new(drawingArea,,{(oDlg:Currentsize()[1]-54)/2,2},{54,22} )
   oSel:Caption := "Select"
   oField:=oSelfield
   oSel:Activate:={||SetDir(oDlg,oDirs,oField)}
   oSel:Create()
RETURN

FUNCTION SetDir(oDlg,oDirs,oField)
   IF oDirs:dirTree:GetData() != NIL
      oField:SetData(oDirs:dirTree:GetData():getdata())
      oDlg:Destroy()
      SetAppfocus(oField)
   ENDIF
RETURN NIL

FUNCTION PathName( cFileName ) 
   LOCAL cPathName := "" 
   LOCAL nPosition := RAt( "\", cFileName ) 

   IF nPosition > 0 
      cPathName := Left( cFileName, nPosition ) 
   ENDIF 
RETURN cPathName 

FUNCTION LockRec()
LOCAL I := 0
LOCAL oDlg,oStatic,a_Size := {350,100}
   DO WHILE !DBRLock(RecNo())   // lock current record
      SLEEP(10) 
      ++I
      IF I = 10
         oDlg:=XbpDialog():New(SetAppWindow():DrawingArea,,CenterPos(a_Size,SetAppWindow():CurrentSize()),a_Size)
         oDlg:border := XBPDLG_NO_BORDER
         oDlg:TitleBar := .F.
         oDlg:Create()     
         oStatic := XbpStatic():New(oDlg:drawingArea,,{0,0},a_Size)
         oStatic:Options := XBPSTATIC_TEXT_CENTER+XBPSTATIC_TEXT_VCENTER
         oStatic:Type := XBPSTATIC_TYPE_TEXT
         oStatic:Caption := "Record is temporarily unavailable. Please be patient.."+ALIAS()
         oStatic:Create()
         oDlg:Show()
      ENDIF
   ENDDO 
   IF I >= 10
      oDlg:Destroy()
   ENDIF
RETURN .T.

FUNCTION AppendRec()
LOCAL I := 0
LOCAL oDlg,oStatic,a_Size := {390,100}
   DBAPPEND(1)   // add new record don't release other locks
   DO WHILE NetErr()   
      SLEEP(10) 
      ++I
      IF I = 10
         oDlg:=XbpDialog():New(SetAppWindow():DrawingArea,,CenterPos(a_Size,SetAppWindow():CurrentSize()),a_Size)
         oDlg:border := XBPDLG_NO_BORDER
         oDlg:TitleBar := .F.
         oDlg:Create()     
         oStatic := XbpStatic():New(oDlg:drawingArea,,{0,0},a_Size)
         oStatic:Options := XBPSTATIC_TEXT_CENTER+XBPSTATIC_TEXT_VCENTER
         oStatic:Type := XBPSTATIC_TYPE_TEXT
         oStatic:Caption := "A new Record is temporarily unavailable. Please be patient.."+ALIAS()
         oStatic:Create()
         oDlg:Show()
      ENDIF
      DBAPPEND(1)
   ENDDO 
   IF I >= 10
      oDlg:Destroy()
   ENDIF
RETURN .T.

// pass buffer by reference ie @Buffer
FUNCTION freadln(handle, buffer, endchar)
   local max_line := 2048
   local line, eol, num_read, save_pos, epointer
   // if not defined, then end of line is a 13
   if valtype(endchar) <> "N"
        endchar = 13
   endif
   buffer := ""
   line   := space(max_line)
   // save current file position for later seek
   save_pos := fseek(handle, 0, FS_RELATIVE)
   num_read := fread(handle,@line, max_line)
   IF (eol := at(CHR(endchar), substr(line,1,num_read))) = 0
        buffer := line
   ELSE
        * copy up to EOL
        buffer = substr(line,1,eol-1)
        * now position file to next line
        IF substr(line,1,eol+1)=chr(10) // linefeed position past it
           fseek (handle,save_pos+eol+1,FS_SET)
        ELSE
           fseek (handle,save_pos+eol,FS_SET)
        ENDIF
   ENDIF
   // now filter out any characters below/equal 30
   epointer := 1
   while epointer <= 5 //len(buffer)
      if asc(substr(buffer,epointer,1)) <= 30
         IF epointer = 1                   // get the right side
            buffer := substr(buffer,2)
         ELSE                              // get parts from both sides
            buffer := substr(buffer,1,epointer-1)+substr(buffer,epointer+1)
         ENDIF
      endif
      ++epointer
   enddo
RETURN num_read != 0

FUNCTION DBFTYPE(cFileName)
LOCAL cType := "DBF",fhnd,Buffer := " "
   fhnd := Fopen(cFilename,FO_READ)
   IF fhnd = -1
      RETURN ""
   ENDIF
   fread(fhnd,@Buffer,1)
   IF ASC(BUFFER) = 0X30 .OR. ASC(BUFFER) = 0X31
      cType := "FOX"
   ENDIF
   Fclose(fhnd)
RETURN cType




PROCEDURE BusyPointer(o,lBusy) 
LOCAL nPointer,I
  IF lBusy
     nPointer := XBPSTATIC_SYSICON_WAIT
  ELSE
     nPointer := XBPSTATIC_SYSICON_DEFAULT  
  ENDIF  
  o:setPointer(, nPointer, XBPWINDOW_POINTERTYPE_SYSPOINTER  )   
  FOR I = 1 TO LEN(o:ChildList())
     IF LEN(o:ChildList()[I]:ChildList())>0
        BusyPointer(o:ChildList()[I],lBusy)
     ELSE
        o:ChildList()[I]:setPointer(, nPointer, XBPWINDOW_POINTERTYPE_SYSPOINTER  )
     ENDIF    
  NEXT I
RETURN