///////////////////////////////////////////////////////////////////////////////
//
//  Class code created by the Xbase++ FormDesigner
//    Creation date: 03/19/05 Creation time: 16:09:50
//
//  Contents  :
//    This file contains the basic structure for the utilization-level of
//    a form. It may (and sould) be modified.
//
///////////////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "class.ch"
#include "Dmlb.ch"
#include "inkey.ch"
#include "dll.ch"

//#define USETOOLTIP
#define TOOLSTARTID 650

******************************************************************************
* This class is derived from the implementation-level class of the form.
* Instance variables are declared in the _PopUpBrowse class.
******************************************************************************
CLASS PopUpBrowse FROM _PopUpBrowse
   EXPORTED:
      METHOD init,Keyboard,resize,destroy,SetIndex,NotifyList
      METHOD create,SeekKeyBoard,SetSelected,SetUnselected,Update
      VAR DBArea,aField,aWidth,aHeader,BrowseSize,aIndex,aDataType
      VAR oCtrl,SelectedBGColor,UnselectedBGColor,IndexFGColor,oBrowse,aLastPos,TopMargin
      VAR DefaultOrder,CurrentIndex,IsSelected,IsDescend,Filter,TopScope,BottomScope,BothScope
      VAR UpdateFields,Addblock,PosTop,OldOrd,AddKey,AddCaption,Aux1Block,Aux1Key,Aux1Caption,Focus2Browse,IsScoped,IsScopedBoth
      VAR SelIndexFGColor,lNoSeek,SeekPrefix,lAborted,lStrZSeek
ENDCLASS

******************************************************************************
* Initialize form
******************************************************************************
METHOD PopUpBrowse:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   * Execute method of the super class
   ::_PopUpBrowse:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::Close := {||::oCtrl:lAborted:=.T.,::Destroy()}

   ::UnselectedBGColor := GRAMAkeRGBColor({0X83,0XC2,0XDD})
   ::SelectedBGColor   := GRAMAkeRGBColor({0X97,0XE0,0XFF})
   ::IndexFGColor      := GRAMAkeRGBColor({0XFF,0X00,0X00})
   ::SelIndexFGColor   := GRAMAkeRGBColor({0XFF,0XFF,0XFF})

   ::OkButton:Activate   := {||::Update(),::Destroy()}
   ::QuitButton:Activate := {||Eval(::Close)}

   ::aLastPos     := {}
   ::TopMargin    := 35
   ::DefaultOrder := 1
   ::CurrentIndex := 0
   ::IsSelected   := .F.
   ::IsDescend    := .F.
   ::UpdateFields := {}
   ::aDataType    := {}
   ::AddBlock     := NIL
   ::Aux1Block    := NIL
   ::Aux1Key      := NIL
   ::Aux1Caption  := "Aux1"
   ::PosTop       := .F.
   ::AddKey       := xbeK_ALT_A
   ::AddCaption   := "Add"
   ::Focus2Browse := .F.
   ::IsScoped     := .F.
   ::IsScopedBoth := .F.
   ::lNoSeek      := .F.
   ::SeekPrefix   := ""  
   ::lStrZSeek    := .F.
   ::SeekString:KeyBoard := {|nKey|::SeekKeyBoard(nKey,::SeekString)}

RETURN self


******************************************************************************
* Request system resources
******************************************************************************
METHOD PopUpBrowse:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
LOCAL I,bBlock,nWide,HelpPrefix:="Generic popup browse-",aStruct

   * Execute method of the super class
   ::_PopUpBrowse:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   aPP := {{XBP_PP_HILITE_FGCLR, GRA_CLR_BLACK},{XBP_PP_HILITE_BGCLR, GRA_CLR_YELLOW}}
   ::oBrowse := JimsBrowse():New(::BrowseBox,,{0,0},::BrowseBox:CurrentSize(),aPP)
/*/xbp
   ::oBrowse := XbpBrowse():New(::BrowseBox,,{0,0},::BrowseBox:CurrentSize(),aPP)
   ::oBrowse:skipBlock     := {|n| (::DBArea)->(DbSkipper(n)) }
   ::oBrowse:goTopBlock    := {| | (::DBArea)->(DbGoTop())    }
   ::oBrowse:goBottomBlock := {| | (::DBArea)->(DbGoBottom()) }
   ::oBrowse:phyPosBlock   := {| | (::DBArea)->(Recno())      }

   // Code blocks for the vertical scrollbar.
   // Note: DbPosition() returns values in the range from 0 to 100.
   ::oBrowse:posBlock      := {| | (::DBArea)->(DbPosition())    }
   ::oBrowse:goPosBlock    := {|n| (::DBArea)->(DbGoPosition(n)) }
   ::oBrowse:lastPosBlock  := {| | 100             }
   ::oBrowse:firstPosBlock := {| | 0               }
//xbp
*/
   ::oBrowse:CursorMode := XBPBRW_CURSOR_ROW
   ::oBrowse:DBArea := ::DBArea
   aStruct := (::DBarea)->(DBStruct())
   FOR I = 1 TO LEN(::aField)
      bBlock := &("{||"+::DBarea+"->"+::aField[I]+"}")
      nWide := IF(LEN(::aHeader[I])>::aWidth[I],LEN(::aHeader[I]),::aWidth[I])
      ::oBrowse:addColumn( bBlock,nWide,::aHeader[I] )
      ::oBrowse:GetColumn(I):Heading:Cargo := I  // self reference for column pos
      IF !EMPTY(::aIndex)
         ::oBrowse:GetColumn(I):Heading:RBClick := {|aPos,y,o|::SetIndex(o)}
         IF !EMPTY(::aIndex[I])
            ::oBrowse:GetColumn(I):Heading:SetColorFG(::IndexFGColor)
         ENDIF
      ENDIF
	  If (::DBarea)->(FieldPos(::aField[I])) # 0
        AADD(::aDataType,aStruct[(::DBarea)->(FieldPos(::aField[I])),2])
	  Else
        AADD(::aDataType,"C")
	  EndIF
   NEXT I
   ::oBrowse:ItemSelected := {|| EVAL(::OkButton:Activate)}
   ::oBrowse:itemMarked   := {|| ::NotifyList()}
   ::oBrowse:TabStop := .T.
   ::oBrowse:Create()
   ::SetUnselected()
   ::OldOrd := (::DbArea)->(OrdSetFocus())
   FOR I = 1 TO LEN(::aField)
      IF I = ::DefaultOrder
         ::SetIndex(::oBrowse:GetColumn(I):Heading)
      ENDIF
   NEXT I
   ::oBrowse:SetInputFocus  := {||::SetSelected()}
   ::oBrowse:KillInputFocus := {||::SetUnSelected()}
   SetClipperStyle(::DrawingArea) // set clipper nav to non-SLE objects code in multidialog.prg
   IF ::PosTop
     (::DbArea)->(DBGoTop())
   ENDIF
//   (::DbArea)->(DBClearScope( ))
   IF EMPTY(::BothScope)
      IF !EMPTY(::TopScope)
         (::DbArea)->(DBSetScope(SCOPE_TOP,::TopScope))
         ::IsScoped := .T.
      ENDIF
      IF !EMPTY(::BottomScope)
         (::DbArea)->(DBSetScope(SCOPE_BOTTOM,::BottomScope))
         ::IsScoped := .T.
      ENDIF
   ELSE
      (::DbArea)->(DBSetScope(SCOPE_BOTH,::BothScope))
      ::IsScopedBoth := .T.
   ENDIF
   IF VALTYPE(::Filter) = "B"
      (::DbArea)->(DBSetFilter(::Filter))
   ENDIF
   IF ::oCtrl:IsDerivedFrom("XbpSLE")
      IF !::PosTop .AND. !EMPTY(::oCtrl:EditBuffer()) .AND. !EMPTY(::oBrowse:GetColumn(1):Heading:Cargo)  // there is a index on column 1
        (::DbArea)->(DBSeek(::oCtrl:EditBuffer(),,::oBrowse:GetColumn(1):Heading:Cargo))
        IF (::DbArea)->(EOF())
           (::DbArea)->(DBGoTop())
        ENDIF
      ELSE
        (::DbArea)->(DBGoTop())
      ENDIF
   ENDIF
   ::oBrowse:RefreshAll()
//   (::DBarea)->(DBRegisterClient(::oBrowse)) //register the object with the dbf

#ifdef USETOOLTIP
   // Tooltips
   ::SeekString:helpLink := MagicHelpLabel():New(TOOLSTARTID+1,HelpPrefix+"Seek string")
   ::oBrowse:helpLink := MagicHelpLabel():New(TOOLSTARTID+2,HelpPrefix+"Browse")
   ::OKButton:helpLink := MagicHelpLabel():New(TOOLSTARTID+3,HelpPrefix+"OK Button")
   ::QuitButton:helpLink := MagicHelpLabel():New(TOOLSTARTID+4,HelpPrefix+"Quit Button")
#endif
    * Display the form

   ::show()
   IF VALTYPE(::AddBlock) != "B"
      ::AddButton:Hide()
   ELSE
      ::AddButton:Show()
      ::AddButton:Activate := ::AddBlock
      ::AddButton:SetCaption(::AddCaption)
   ENDIF
   IF VALTYPE(::Aux1Block) != "B"
      ::Aux1Button:Hide()
   ELSE
      ::Aux1Button:Show()
      ::Aux1Button:Activate := ::Aux1Block
      ::Aux1Button:SetCaption(::Aux1Caption)
   ENDIF
   IF ::DefaultOrder = 0 .OR. ::lNoSeek
      SetAppFocus(::oBrowse)
      ::SeekString:Hide()
      ::SeekStatic:Hide()
      ::SeekPrompt:Hide()
   ELSE
      IF ::Focus2Browse
         SetAppFocus(::oBrowse)
      ELSE
         SetAppFocus(::SeekString)
      ENDIF
   ENDIF 
   ::SetInputFocus := {||SetAppFocus(::oBrowse)}

RETURN self

METHOD PopUpBrowse:NotifyList()
LOCAL aList := (::DBArea)->(DbClientList()),I
   FOR I=1 TO LEN(aList)
      IF aList[I]!=::oBrowse
         aList[I]:notify(xbeDBO_Notify,DBO_MOVE_DONE)
      ENDIF
   NEXT I
RETURN self

METHOD PopUpBrowse:Update()
LOCAL I
  IF ValType(::UpdateFields) = "A"
     FOR I = 1 TO LEN(::UpdateFields)
        DO CASE
           CASE ::UpdateFields[I,2]=NIL      // just eval the codeblock
               Eval(::UpdateFields[I,1])
           CASE ::UpdateFields[I,2]:IsDerivedFrom("SLEPic")
               ::UpdateFields[I,2]:SetData(Eval(::UpdateFields[I,1]))
           CASE ::UpdateFields[I,2]:IsDerivedFrom("XbpStatic")
               ::UpdateFields[I,2]:SetCaption(Eval(::UpdateFields[I,1]))
        ENDCASE
     NEXT I
  ENDIF
RETURN Self

METHOD PopUpBrowse:SetIndex(o)
  IF !EMPTY(::aIndex[o:Cargo])
     IF o:Cargo != ::CurrentIndex
        (::DBArea)->(ORDSetFocus(::aIndex[o:Cargo]))
        (::DBArea)->(DbSetDescend(.F.))
        ::IsDescend := .F.
        IF ::CurrentIndex > 0
           IF ::IsSelected
              ::oBrowse:GetColumn(::CurrentIndex):Heading:SetColorBG(::SelectedBGColor)
           ELSE
              ::oBrowse:GetColumn(::CurrentIndex):Heading:SetColorBG(::UnSelectedBGColor)
           ENDIF
           ::oBrowse:GetColumn(::CurrentIndex):Heading:SetColorFG(::IndexFGColor)
        ENDIF
        ::oBrowse:GetColumn(o:Cargo):Heading:SetColorBG(GRAMAkeRGBColor({0XDA,0X00,0X00}))
        ::oBrowse:GetColumn(o:Cargo):Heading:SetColorFG(::SelIndexFGColor)
        IF ::aDataType[o:Cargo] = "D"
           ::SeekString:SetData("")
           ::SeekString:Picture := "99999999"
           ::SeekPrompt:SetCaption(::aHeader[o:Cargo]+" YYYYMMDD")
        ELSE
           ::SeekString:SetData("")
           ::SeekString:Picture := Replicate("!",::aWidth[o:Cargo])
           ::SeekPrompt:SetCaption(::aHeader[o:Cargo])
        ENDIF
        ::CurrentIndex := o:Cargo
        ::oBrowse:RefreshAll()
     ELSE
/*        IF ::IsDescend
           (::DBArea)->(DbSetDescend(.F.))
           ::IsDescend := .F.
        ELSE
           (::DBArea)->(DbSetDescend(.T.))
           ::IsDescend := .T.
        ENDIF
        ::oBrowse:RefreshAll()  */
     ENDIF
  ENDIF
RETURN Self


METHOD PopUpBrowse:SetSelected(aOld,aNew)
LOCAL I
   ::oBrowse:SetColorBG(::SelectedBGColor)
   ::oBrowse:SetColorFG(GRAMAkeRGBColor({0XDA,0X00,0X00}))
   FOR I = 1 TO ::oBrowse:colCount
      ::oBrowse:GetColumn(I):Heading:SetColorBG(::SelectedBGColor)
      IF ::CurrentIndex = I
         ::oBrowse:GetColumn(I):Heading:SetColorBG(GRAMAkeRGBColor({0XDA,0X00,0X00}))
         ::oBrowse:GetColumn(I):Heading:SetColorFG(::SelIndexFGColor)
      ENDIF
   NEXT I
   ::IsSelected := .T.
RETURN Self

METHOD PopUpBrowse:SetUnselected(aOld,aNew)
LOCAL I
   ::oBrowse:SetColorBG(::UnSelectedBGColor)
   ::oBrowse:SetColorFG(GRA_CLR_BLACK)
   FOR I = 1 TO ::oBrowse:colCount
      ::oBrowse:GetColumn(I):Heading:SetColorBG(::UnSelectedBGColor)
      IF ::CurrentIndex = I
         ::oBrowse:GetColumn(I):Heading:SetColorBG(GRAMAkeRGBColor({0XDA,0X00,0X00}))
         ::oBrowse:GetColumn(I):Heading:SetColorFG(::SelIndexFGColor)
      ENDIF
   NEXT I
   ::IsSelected := .F.
RETURN Self

METHOD PopUpBrowse:Resize(aOld,aNew)
LOCAL aDif,TopMargin
   // IF first time through
   IF LEN(::aLastPos) = 0
      AADD(::aLastPos,::SeekStatic:CurrentPos()) //1
      AADD(::aLastPos,::SeekString:CurrentPos()) //2
      AADD(::aLastPos,::SeekPrompt:CurrentPos()) //3
   ENDIF
   //Calc change in size
   aDif := {aNew[1]-aOld[1],aNew[2]-aOld[2]}
   // change right buttons
   ::SeekStatic:SetPos({::aLastPos[1][1],::aLastPos[1][2]+aDif[2]})
   ::SeekString:SetPos({::aLastPos[2][1],::aLastPos[2][2]+aDif[2]})
   ::SeekPrompt:SetPos({::aLastPos[3][1],::aLastPos[3][2]+aDif[2]})
   ::aLastPos[1] := ::SeekStatic:CurrentPos()
   ::aLastPos[2] := ::SeekString:CurrentPos()
   ::aLastPos[3] := ::SeekPrompt:CurrentPos()
   ::BrowseBox:SetSize({::BrowseBox:CurrentSize()[1]+aDif[1],::drawingArea:CurrentSize()[2]-::BrowseBox:CurrentPos()[2]-::TopMargin})
   ::oBrowse:SetSize({::oBrowse:CurrentSize()[1]+aDif[1],::drawingArea:CurrentSize()[2]-::BrowseBox:CurrentPos()[2]-::TopMargin})
RETURN self


METHOD PopUpBrowse:SeekKeyBoard(nKey,o)
LOCAL nPos,PrevRec := (::DBArea)->(Recno())
LOCAL aList := (::DBArea)->(DbClientList()),I
    nPos := o:QueryMarked()[2]
    DO CASE
      CASE nKey = xbeK_RETURN
//          SetAppFocus(::CancelButton)
//          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,::oBrowse)
          RETURN Self
      CASE nKey = xbeK_DOWN
//          PostAppEvent(xbeP_Keyboard,xbeK_DOWN,,::oBrowse)
          RETURN Self
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_UP,,::oBrowse)
          RETURN Self
      CASE nKey = xbeK_PGUP
          PostAppEvent(xbeP_Keyboard,xbeK_PGUP,,::oBrowse)
          RETURN Self
      CASE nKey = xbeK_PGDN
          PostAppEvent(xbeP_Keyboard,xbeK_PGDN,,::oBrowse)
          RETURN Self
      CASE nKey = xbeK_CTRL_PGUP
          PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGUP,,::oBrowse)
          RETURN Self
      CASE nKey = xbeK_CTRL_PGDN
          PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,::oBrowse)
          RETURN Self
      CASE nKey = xbeK_TAB
          RETURN Self
      CASE nKey = xbeK_SH_TAB
          RETURN Self
      CASE nKey = xbeK_ESC
//          Eval(::Close)
          RETURN Self
    ENDCASE
    (::DBArea)->(DbSuspendNotifications())
    IF ::IsScopedBoth
       IF ::lStrZSeek
         (::DBArea)->(DBSeek(::BOTHSCOPE+StrZero(VAL(o:EditBuffer()),::aWidth[::CurrentIndex]),,::aIndex[::CurrentIndex]))
       ELSE  
         (::DBArea)->(DBSeek(::BOTHSCOPE+UPPER(ALLTRIM(o:EditBuffer())),,::aIndex[::CurrentIndex]))
       ENDIF  
    ELSE
       DO CASE
          CASE::aDataType[::CurrentIndex] = "N"
             (::DBArea)->(DBSeek(STR(VAL(o:EditBuffer()),11,2),,::aIndex[::CurrentIndex]))
          OTHERWISE //char
             (::DBArea)->(DBSeek(UPPER(ALLTRIM(o:EditBuffer())),,::aIndex[::CurrentIndex]))
       ENDCASE
    ENDIF
    IF (::DBArea)->(EOF())
       npos := IF(o:querymarked()[2]=1 ,1,o:querymarked()[2]-1)
       o:Setmarked({npos,npos+1})
       o:deletemarked()
       MessageBeep(-1)
//      TONE(400) // let them know
       (::DBArea)->(DBGoto(PrevRec))
    ENDIF
    ::oBrowse:RefreshAll()
    (::DBArea)->(DbResetNotifications())
    FOR I=1 TO LEN(aList)
       aList[I]:notify(xbeDBO_Notify,DBO_MOVE_DONE)
    NEXT I
RETURN self

METHOD PopUpBrowse:KeyBoard(nKey)
   DO CASE
      CASE nKey = xbeK_ESC
         Eval(::Close)
      CASE nKey = xbeK_ALT_Q
         Eval(::QuitButton:Activate)
      CASE VALTYPE(::AddBlock) = "B" .AND. !EMPTY(::AddKey) .AND. nKey = ::AddKey
         Eval(::AddButton:Activate)
      CASE VALTYPE(::Aux1Block) = "B" .AND. !EMPTY(::Aux1Key) .AND. nKey = ::Aux1Key
         Eval(::Aux1Button:Activate)
      OTHERWISE
         ::_PopUpBrowse:KeyBoard(nKey)
   ENDCASE
RETURN Self

METHOD PopUpBrowse:Destroy()

//   (::DBarea)->(DBdeRegisterClient(::oBrowse)) //deregister the object with the dbf
   IF VALTYPE(::Filter) = "B"
     (::DbArea)->(DBClearFilter())
   ENDIF
   IF ::IsScoped .OR. ::IsScopedBoth
      (::DbArea)->(DBClearScope())
   ENDIF
   (::DbArea)->(OrdSetFocus(::OldOrd))

   ::_PopUpBrowse:Destroy()
RETURN Self


DLLFUNCTION MessageBeep() USING STDCALL FROM "USER32.DLL"

* Include program code for the implementation-level class of the form
#define XbpDialog JimsDialog
#define XbpSLE SLEPic
#define XbpCombobox SLEPopup
#ifdef FANCYBUTTON
   #define XbpPushButton ShadowButton
#endif
#include "_MTO_POPUPBROWSE.PRG"

//EOF
/////
