/***********************************
*     PROJECT :MPM                 
*        FILE :MTO_Wait.prg
*  Programmer :James Loughner
*  Created    :10/20/2008
*  
*  A wait dialog in a thread
*************************************/
 
#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "Appbrow.ch" 
#include "Dmlb.ch" 
#include "dll.ch"
#include "inkey.ch"
#include "thread.ch"

#xtrans  CenterPos( <aSize>, <aRefSize> ) => ;
         { Int( (<aRefSize>\[1] - <aSize>\[1]) / 2 ) ;
         , Int( (<aRefSize>\[2] - <aSize>\[2]) / 2 ) }

#define WAITSIZE {330,75}
FUNCTION StartWait(cMsg,oOwner,aPos) 
LOCAL oThread
   oThread := WaitDialog():New()
   oThread:oOwner := oOwner
   oThread:aPos := aPos
   oThread:cMsg := cMsg
   oThread:Start() 
RETURN oThread   

FUNCTION StopWait(oThread) 
   oThread:Terminate() 
RETURN oThread   

   
CLASS WaitDialog FROM Thread 
   PROTECTED: 
      VAR terminated,oDlg 

   EXPORTED: 
      VAR oOwner,aPos,cMsg
      INLINE METHOD init 
         ::Thread:init() 
         ::terminated  := .F. 
      RETURN self 

      INLINE METHOD terminate 
//msgbox("here3")
      RETURN ( ::terminated := .T. ) 

      METHOD execute, checkTermination 
ENDCLASS 

** This method is executed in the thread 
METHOD WaitDialog:execute 
LOCAL oStat,I,cDisp
   IF ::oOwner = NIL 
      ::oOwner := SetAppWindow() 
   ENDIF
   IF EMPTY(::aPos) 
      ::aPos := CenterPos(WAITSIZE,SetAppWindow():DrawingArea:CurrentSize()) 
   ENDIF
   IF EMPTY(::cMsg)
      ::cMsg := "...Processing Please Wait..."
   ENDIF
   
   ::oDlg := XbpDialog():New(AppDeskTop(),::oOwner,::aPos,WAITSIZE)
   ::oDlg:TitleBar := .F.
   ::oDlg:AlwaysOnTop := .T.
   ::oDlg:Border := XBPDLG_NO_BORDER
   ::oDlg:create()
   oStat := XbpStatic():New(::oDlg:DrawingArea,,CenterPos({WAITSIZE[1],25},WAITSIZE),{WAITSIZE[1],25})
   oStat:Type := XBPSTATIC_TYPE_TEXT
   oStat:Options := XBPSTATIC_TEXT_CENTER + XBPSTATIC_TEXT_VCENTER 
   oStat:Caption := ::cMsg
   oStat:Create()
   ::oDlg:SetModalState(XBP_DISP_APPMODAL)  
   I := 1
   cDisp := ""
   DO WHILE !::terminated  
      cDisp += ::cMsg[I]
      oStat:SetCaption(cDisp)
      SLEEP(10)
      ++I
      IF I > LEN(::cMsg)
         I := 1
         cDisp := ""
      ENDIF 
      ::checkTermination() 
   ENDDO
   
//msgbox("here2")
   ::oDlg:SetModalState(XBP_DISP_MODELESS)
   ::oDlg:destroy() 
   ::quit() 
RETURN self 

** This method checks whether or not the thread must 
** terminate and cancels it, if necessary 
METHOD WaitDialog:checkTermination 
   IF ::terminated 
//      ::terminated := .F. 
//msgbox("here")
      ::oDlg:SetModalState(XBP_DISP_MODELESS)
      ::oDlg:destroy() 
      ::quit() 
   ENDIF 
RETURN self 


