/***********************************
*     PROJECT :ShadowText          
*        FILE :ShadowButton.prg
*  Programmer :James Loughner
*  Created    :05/15/04
*  
*  Button from Active text
*************************************/
 
#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "Appbrow.ch" 
#include "Dmlb.ch" 
#include "dll.ch"
#include "inkey.ch"

#pragma Library("xbtbase1.lib")



CLASS ShadowButton FROM ActiveText
   EXPORTED:
      METHOD Init,create,PaintIt,Motion,Hilite,SetInputFocus,KillInputFocus,Enable,Disable,Activate,Keyboard
      METHOD HandleEvent,Show,Draw,Destroy,Paint
      VAR HoverColorBG,ActivateColorBG,Model,ColorBG,UseHiLites,nRadius,DisableColorBG,DisableColorFG
ENDCLASS       

METHOD ShadowButton:Init(oParent, oOwner, aPos, aSize, aPP, lVisible)
   ::ActiveText:Init(oParent, oOwner, aPos, aSize, aPP, lVisible) 
   ::HoverColorBG := GraMakeRGBColor({255,255,255})
   ::ActivateColorBG := GraMakeRGBColor({255,255,255})
   ::ColorBG := GraMakeRGBColor({255,255,255})
   ::Model :="FANCY"
   ::TextColor := GraMakeRGBColor({0,155,0})  
   ::HoverColorFG := GraMakeRGBColor({0,0,0}) 
   ::ActivateColorFG := GraMakeRGBColor({0,255,0})
   ::DisableColorBG := GraMakeRGBColor({0X89,0X89,0X6E})
   ::DisableColorFG := GraMakeRGBColor({0XAB,0X00,0X00})
   ::UseHiLites := .T.
   ::ShadowRefRGB := ::HoverColorBG 
   ::nRadius := 4  
   ::lHasInput := .F.
//   ::DrawMode := XBP_DRAW_OWNER  
RETURN Self

METHOD ShadowButton:Create(oParent, oOwner, aPos, aSize, aPP, lVisible)
   ::ActiveText:Create(oParent, oOwner, aPos, aSize, aPP, lVisible)
   ::ShadowRefRGB := ::HoverColorBG 
   ::Motion({1,1})
   ::Enable() 
RETURN Self

METHOD ShadowButton:Destroy()
  ::ActiveText:Destroy()
RETURN Self

METHOD ShadowButton:Show()
   ::XbpPushButton:Show()
   ::Paint()
RETURN Self

METHOD ShadowButton:Draw(oPS,aInfo)
   ::PaintIt(,oPS)
RETURN Self

METHOD ShadowButton:Paint()
LOCAL oPS
   oPS := ::LockPS()
   ::PaintIt(,oPS)
   ::UnLockPS()
RETURN Self

METHOD ShadowButton:HandleEvent(nEvent,mp1,mp2)
   IF nEvent = xbeP_Paint
//     ALTD()
   ENDIF 
RETURN ::ActiveText:HandleEvent(nEvent,mp1,mp2)

METHOD ShadowButton:SetInputFocus()
   IF !::IsDown
      ::IsShadow := .F.
      ::ShadowDepth := 0
      ::TextColor := ::HoverColorFG  
      ::lHasInput := .T.
   ENDIF
   ::Paint()
//   PostAppEvent(xbeP_Paint,,,Self)  
//   SetAppFocus(::ActiveText)
RETURN ::ActiveText:SetInputFocus()

METHOD ShadowButton:KillInputFocus()
   ::SetOff()   
   ::lHasInput := .F.
RETURN ::ActiveText:KillInputFocus()

METHOD ShadowButton:Enable()
   ::ActiveText:Enable()
   ::IsShadow := .F. 
   ::ShadowDepth := 0
   ::TextColor := ::ColorFG
   ::Paint()
RETURN Self

METHOD ShadowButton:Disable()
   ::ActiveText:Disable()
   ::IsShadow := .F. 
   ::ShadowDepth := 0
   ::TextColor := ::DisableColorFG
   ::Paint()
RETURN Self

METHOD ShadowButton:Activate()
   ::ActiveText:Activate()
   ::IsShadow := .F. 
   ::ShadowDepth := 0
   ::TextColor := ::ActivateColorFG
   ::Paint()
RETURN Self

METHOD ShadowButton:Motion(aPos)
LOCAL o:=::SetParent(),I,oSib:=::SetParent():ChildList()
   IF ::IsEnabled()
      ::ActiveText:Motion(aPos)
   ENDIF
RETURN Self

METHOD ShadowButton:Hilite(Hue1,Hue2,oPS)
LOCAL I,aAttrL,lPS:=.F. 
   IF ::UseHiLites
      IF ::Model = "FANCY"
         aAttrL := ARRAY( GRA_AL_COUNT )   // set various attributes  
         aAttrL[GRA_AL_WIDTH]:= 1 
     //    GraSetAttrLine( ::oPS, aAttrL )
         I=0
         
         FOR I = 0 TO 1
            GraSetColor(oPS,Hue1)
            GRALINE(oPS,{I,::nRadius},{I,::CurrentSize()[2]-::nRadius-I})
            GRAARC(oPS,{::nRadius+I,::nRadius+I},::nRadius+I,,180,45)
            GRAARC(oPS,{::nRadius+I,::CurrentSize()[2]-::nRadius-I},::nRadius+I,,90,90)
            GRALINE(oPS,{I+::nRadius,::CurrentSize()[2]-I-1},{::CurrentSize()[1]-::nRadius-I,::CurrentSize()[2]-I-1})
            GRAARC(oPS,{::CurrentSize()[1]-(::nRadius+I),::nRadius},::CurrentSize()[2]-(::nRadius+I),,45,45)
            GraSetColor(oPS,Hue2)
            GRAARC(oPS,{::CurrentSize()[1]-(::nRadius+I),::nRadius},::CurrentSize()[2]-(::nRadius+I),,0,45)
            GRALINE(oPS,{::CurrentSize()[1]-I,::CurrentSize()[2]-::nRadius-I},{::CurrentSize()[1]-I,::nRadius+I})
            GRAARC(oPS,{::CurrentSize()[1]-(::nRadius+I),::nRadius+I},::nRadius+I,,270,90)
            GRALINE(oPS,{::CurrentSize()[1]-I-::nRadius,I},{::nRadius+I,I})
            GRAARC(oPS,{::nRadius+I,::nRadius+I},::nRadius+I,,225,45)
            GraSetColor(oPS,GRA_CLR_BLACK)
         NEXT I
      ELSE
         FOR I = 0 TO 1
            GraSetColor(oPS,Hue1)
            GRALINE(oPS,{I,I},{I,::CurrentSize()[2]-I})
            GRALINE(oPS,,{::CurrentSize()[1]-I,::CurrentSize()[2]-I})
            GraSetColor(oPS,Hue2)
            GRALINE(oPS,,{::CurrentSize()[1]-I,I})
            GRALINE(oPS,,{I,I})
            GraSetColor(oPS,GRA_CLR_BLACK)
         NEXT I
      ENDIF
   ENDIF
RETURN Self


METHOD ShadowButton:PaintIt(aRect,oPS)
LOCAL aAttr,aAttrL,Hue,I,J,oPP,aPC,nStart,nEnd,nStep,lPS:=.F.
   //draw button 
   IF ::NormalButton // no painting just use standard button
      RETURN ::XbpPushButton:Paint(aRect)
   ENDIF
   IF EMPTY(oPS) 
//   MSGBOX("LOCK")
      oPS := ::LockPS()
      lPS := .T.  
   ENDIF
   aAttr := ARRAY( GRA_AA_COUNT )   // set various attributes
   aAttrL := ARRAY( GRA_AL_COUNT )   // set various attributes

   DO CASE
      CASE ::IsDown
         aAttr[ GRA_AS_COLOR ] := IF(!::IsEnabled(),::DisableColorBG,::ActivateColorBG) 
         ::Hilite(GraMakeRGBColor({0x7D,0x7D,0x7D}),GraMakeRGBColor({0xBD,0xBD,0xBD}),oPS)
         aAttrL[GRA_AL_COLOR] := aAttr[ GRA_AS_COLOR ]
      CASE ::IsShadow .OR. SetAppFocus() = Self
         aAttr[ GRA_AS_COLOR ] := IF(!::IsEnabled(),::DisableColorBG,::HoverColorBG) 
         ::Hilite(GraMakeRGBColor({0xBD,0xBD,0xBD}),GraMakeRGBColor({0x7D,0x7D,0x7D}),oPS)
         aAttrL[GRA_AL_COLOR] := aAttr[ GRA_AS_COLOR ]
      CASE !::IsShadow
         aAttr[ GRA_AS_COLOR ] := IF(!::IsEnabled(),::DisableColorBG,::ColorBG)
         ::Hilite(GraMakeRGBColor({0x7D,0x7D,0x7D}),GraMakeRGBColor({0xBD,0xBD,0xBD}),oPS)
         aAttrL[GRA_AL_COLOR] := aAttr[ GRA_AS_COLOR ]
      OTHERWISE
         aAttr[ GRA_AS_COLOR ] := IF(!::IsEnabled(),::DisableColorBG,::ColorBG)
         ::Hilite(GraMakeRGBColor({0x7D,0x7D,0x7D}),GraMakeRGBColor({0xBD,0xBD,0xBD}),oPS)
         aAttrL[GRA_AL_COLOR] := aAttr[ GRA_AS_COLOR ]
   ENDCASE
   ::ShadowRefRGB := aAttr[ GRA_AS_COLOR ]
   GraSetAttrArea( oPS, aAttr )
   GraSetAttrLine( oPS, aAttrL )
   IF ::Model = "FANCY"
      GRABOX(oPS,{1,2},{::CurrentSize()[1]-2,::CurrentSize()[2]-2},GRA_OUTLINEFILL,::nRadius,::nRadius)
      J := 1
      oPP := ::ShadowRefRGB
      aPC := GraGetRGBIntensity(oPP)
      oPP := RGBToHSB(aPC)
      IF ::IsShadow
         nStart := INT(::CurrentSize()[2]/2)
         nEnd := ::CurrentSize()[2]-2
         nStep := 1 
      ELSE
         nStart := INT(::CurrentSize()[2]/2)
         nEnd := 3
         nStep := -1 
      ENDIF   
      FOR I = nStart TO nEnd STEP nStep
         oPP[3] -= 1
         aPC := HSBToRGB(oPP)
         Hue := GraMakeRGBColor({Int(aPC[1]),Int(aPC[2]),Int(aPC[3])})
         GraSetColor(oPS,Hue)
         GRALINE(oPS,{4,I},{::CurrentSize()[1]-4,I})
         ++J
      NEXT I
   ELSE
      GRABOX(oPS,{1,2},{::CurrentSize()[1]-2,::CurrentSize()[2]-2},GRA_OUTLINEFILL)
   ENDIF
   
   ::ActiveText:PaintIt(aRect,oPS)  // now paint the text
   IF lPS
      ::UnLockPS()
   ENDIF

RETURN Self  

METHOD ShadowButton:Keyboard(nKey)
//   DO CASE
//      CASE nKey = xbeK_SPACE //.OR. nKey = xbeK_ENTER
//          PostAppEvent( xbeM_LbDown,{1,1},,Self)
//          PostAppEvent( xbeM_LbUp,{1,1},,Self)
//      OTHERWISE
         ::ActiveText:Keyboard(nKey)
//   ENDCASE  
RETURN Self 

CLASS ActiveText FROM ShadowText
   EXPORTED:
      VAR Activate,HoverColorFG,ActivateColorFG,ColorFG,Depth,IsShadow,lHasInput
      METHOD Motion,Init,Create,lbUp,lbDown
      METHOD SetOff,Enter,Leave
   PROTECTED: 
      VAR IsDown,SkipLBUp,BMCaption,ParentDlg,IsShadowDn 
      VAR OldKIF
ENDCLASS

METHOD ActiveText:Init(oParent, oOwner, aPos, aSize, aPP, lVisible)
   ::ShadowText:Init(oParent, oOwner, aPos, aSize, aPP, lVisible) 
   ::IsDown := .F. 
   ::IsShadow := .F.    
   ::IsShadowDn := .F.
   ::SkipLBUp := .F.
   ::TextColor := GraMakeRGBColor({0,0,0})  
   ::ShadowDepth := 0
   ::Depth := 4 
   ::HasFocus := .F. 
   ::lHasInput := .F.
RETURN Self         

METHOD ActiveText:Create(oParent, oOwner, aPos, aSize, aPP, lVisible)
   ::ShadowText:Create(oParent, oOwner, aPos, aSize, aPP, lVisible)
   IF ::HoverColorFG = NIL
      ::HoverColorFG := GRA_CLR_WHITE 
   ENDIF
   IF ::ActivateColorFG = NIL
      ::ActivateColorFG := GRA_CLR_RED
   ENDIF
   ::ColorFG := ::TextColor
   ::ParentDlg := ::setParent()
   DO WHILE !::ParentDlg:IsderivedFrom("XbpDialog")
      ::ParentDlg := ::ParentDlg:SetParent()
   ENDDO       
   ::OldKIF := ::ParentDlg:killInputFocus
   ::ParentDlg:killInputFocus := {|| ::SetOff() }
   ::Paint()
RETURN Self         

METHOD ActiveText:SetOff(cPer)
//   IF ::IsShadow
      ::TextColor := ::ColorFG 
      ::ShadowDepth := 0
      ::Paint()  
      ::IsShadow := .F.
      ::CaptureMouse(.F.) 
      IF !EMPTY(::OldKIF) .AND. cPer = NIL
         EVAL(::OldKIF,NIL,NIL,::ParentDlg)
      ENDIF
//   ENDIF
RETURN Self
   
METHOD ActiveText:Enter(aPos)
   IF ::IsEnabled()
      ::TextColor := ::HoverColorFG
      ::ShadowDepth := ::Depth
      ::IsShadow := .T.
      ::Paint()
   ENDIF
RETURN Self

METHOD ActiveText:Leave(aPos)
   IF ::IsEnabled()
      ::TextColor := IF(::lHasInput,::HoverColorFG,::ColorFG)
      ::ShadowDepth := 0
      ::IsShadow := .F.
      ::Paint()
   ENDIF
RETURN Self

METHOD ActiveText:Motion(aPos)
LOCAL n:=0
LOCAL CurDlgFocus := SetAppFocus()
   ::SkipLBUp := .F. 
RETURN Self         

   
METHOD ActiveText:lBUp(aPos)
   ::CaptureMouse(.F.)
   ::ShadowText:lbUp(aPos)
   IF !::SkipLBUp .AND. ::IsDown
      ::TextColor := ::HoverColorFG
      ::ShadowDepth := ::Depth
      ::Paint() 
      ::IsDown := .F. 
      ::IsShadowDn := .F.
      IF !EMPTY(::Activate)
         ::CaptureMouse(.F.)
         ::IsShadowDn := .T.
         EVAL(::Activate,,,Self)
         ::SKipLBUp := .T.
         ::IsShadowDn := .F.   
      ENDIF
   ENDIF  
   ::SKipLBUp := .F.
RETURN Self         

METHOD ActiveText:lBDown(aPos)
LOCAL CurDlgFocus := SetAppFocus()
   ::ShadowText:lbDown(aPos)
   ::TextColor := ::ActivateColorFG
   ::ShadowDepth := 0
   ::IsDown := .T. 
   ::IsShadow := .F.
   ::Paint()  
   SetAppFocus(Self)
RETURN Self         
      
// note: requires XbpTools linked!!!! or SIN COS functions
CLASS ShadowText FROM XbpPushButton
EXPORTED:
   METHOD Init,Create,PaintIt,Destroy,SetCaption,setFontCompoundName,SetFont
   ACCESS ASSIGN METHOD Caption VAR Caption 
   VAR Angle,TextColor,ShadowDepth,oFont,oPS,DefFont,AutoSize
   VAR IsAuto,FirstTime,ShadowRefRGB,HasFocus,cFontName,NormalButton  
ENDCLASS

METHOD ShadowText:Init(oParent,oOwner,aPos,aSize,aAttr,lVisable)
   ::XbpPushButton:Init(oParent,oOwner,aPos,aSize,aAttr,lVisable)
   ::Caption := ""
   ::Angle := 0
   ::TextColor := GraMakeRGBColor({0,0,0}) // default black
   ::ShadowDepth := 3
   ::DefFont := "8.Arial bold"
   ::IsAuto := .F.
   IF EMPTY(aSize)
     ::AutoSize := .T.
   ELSE
     ::AutoSize := .F.
   ENDIF 
   ::FirstTime := .T.
   ::NormalButton := .F.

//   ::clipSiblings := .T.
RETURN Self

METHOD ShadowText:Create(oParent,oOwner,aPos,aSize,aAttr,lVisable)
   ::XbpPushButton:Create(oParent,oOwner,aPos,aSize,aAttr,lVisable)
   ::XbpPushButton:SetColorBG(XBPSYSCLR_TRANSPARENT)
//   ::oPS := XBPPresSpace():New():Create(Self:WinDevice(),Self:CurrentSize(),GRA_PU_PIXEL) 
   IF EMPTY(::oFont)
      ::setFontCompoundName(::DefFont)
   ENDIF
   IF ::AutoSize
      ::Paint()
   ENDIF
   ::SetTrackPointer(.T.)

RETURN Self

METHOD ShadowText:SetCaption(cText)
   ::Caption := cText
   ::XbpPushButton:SetCaption(cText)
   ::Paint()
RETURN .T.

METHOD ShadowText:Caption(cText)
   IF VALTYPE(cText) = "C"
      ::Caption := cText
      ::XbpPushButton:Caption := cText 
   ENDIF   
RETURN ::Caption

METHOD ShadowText:setFontCompoundName(cFont,oPS)
LOCAL fRtn,lPS := .F.
   IF VALTYPE(::oFont)="O"
      fRtn := ::oFont:CompoundName
      ::oFont:Configure(cFont)
   ELSE
      IF EMPTY(oPS)
         oPS := AppDeskTop():LockPS()
         lOPS := .T.
      ENDIF   
      ::oFont := XbpFont():new(oPS)
      ::oFont:create(cFont)
      fRtn := ::oFont 
      IF lPS
         AppDeskTop():UnLockPS()
      ENDIF   
   ENDIF
RETURN fRtn

METHOD ShadowText:setFont(oFont)
LOCAL fRtn := ::oFont
   ::oFont:= oFont
RETURN fRtn


METHOD ShadowText:PaintIt(aRect,oPS)
LOCAL oFont,aPoints
LOCAL aAttr, aAngle, nX, nY, oPP, aPC := {}, nBClr


  IF ::IsAuto
     RETURN Self
  ENDIF
  IF ::ShadowRefRGB = NIL
     oPP := ::XbpPushButton:SetParent():SetColorBG()
     aPC := GraGetRGBIntensity(oPP)
  ELSE
     oPP := ::ShadowRefRGB
     aPC := GraGetRGBIntensity(oPP)
  ENDIF
  oPP := RGBToHSB(aPC)
  oPP[3] -= 20
  aPC := HSBToRGB(oPP)
  nBClr := GraMakeRGBColor({Int(aPC[1]),Int(aPC[2]),Int(aPC[3])})

  aAngle := {100*cos(DtoR(::Angle)),100*sin(DtoR(::Angle))}
  IF EMPTY(::oFont)
     ::setFontCompoundName(::DefFont,oPS)
  ENDIF   
  GraSetFont( oPS,::oFont)


  aAttr := ARRAY( GRA_AS_COUNT )   // set various attributes

  //** the drop shadow
  aAttr [ GRA_AS_COLOR     ] := nBClr
  aAttr [ GRA_AS_ANGLE     ] := aAngle

  GraSetAttrString( oPS, aAttr )
  //** Size static
  aPoints := GraQueryTextBox(oPS,::Caption)
  IF ::AutoSize
     ::IsAuto := .T. // prevent infinit loops
     nX := MAX(MAX(ABS(aPoints[1,1]),ABS(aPoints[2,1])),MAX(ABS(aPoints[3,1]),ABS(aPoints[4,1])))+ABS(::ShadowDepth)+5
     nY := MAX(MAX(ABS(aPoints[3,2]),ABS(aPoints[4,2])+ABS(aPoints[1,2])),MAX(ABS(aPoints[1,2]),ABS(aPoints[2,2])))+ABS(::ShadowDepth)+5
     IF nX != ::CurrentSize()[1] .OR. nY != ::CurrentSize()[2]
        ::SetSize({nX,nY}) 
     ENDIF
     ::IsAuto := .F.
  ENDIF

  //** Find center offset
  nX := (::CurrentSize()[1]-MAX(MAX(aPoints[1,1],aPoints[2,1]),MAX(aPoints[3,1],aPoints[4,1]))-::ShadowDepth+ABS(aPoints[1,1]-aPoints[2,1]))/2
  nY := (::CurrentSize()[2]-MAX(MAX(aPoints[3,2],aPoints[4,2]),MAX(aPoints[1,2],aPoints[2,2]))+::ShadowDepth)/2
  IF ::Angle < 0
     nX := (::CurrentSize()[1] -ABS(aPoints[3,1])-ABS(::ShadowDepth)+ABS(aPoints[1,1]-aPoints[2,1]))/2
     nY := (::CurrentSize()[2] +MAX(ABS(aPoints[3,2])+ABS(aPoints[1,2]),ABS(aPoints[4,2])+ABS(aPoints[2,2]))-ABS(::ShadowDepth))/2
  ENDIF

  ::Caption := STRTRAN(::Caption,"~","")
  IF ::ShadowDepth != 0
     GraStringAt(oPS, {nX+::ShadowDepth,nY-::ShadowDepth}, STRTRAN(::Caption,"&",""))
  ENDIF   

  //** the normal text
  aAttr [ GRA_AS_COLOR     ] := ::TextColor

  GraSetAttrString( oPS, aAttr )
  GraStringAt(oPS, {nX,nY}, STRTRAN(::Caption,"&",""))
  

RETURN Self

METHOD ShadowText:Destroy()
   ::oFont:Destroy()
//   ::oPS:Destroy()
   ::SetTrackPointer(.F.)
   ::XbpPushButton:Destroy()
RETURN Self


//** convert HSB to RGB (aHSL should be {HUE,SATURATION,BRIGHTNESS})
FUNCTION HSBToRGB(aHSL)
  LOCAL R,G,B,H,S,L,nH,nS,nL,nF,nP,nQ,nT,lH

  H := aHSL[1]
  S := aHSL[2]
  L := aHSL[3]

  IF S > 0

    nH := H / 60
    nL := L / 100
    nS := S / 100

    lH := Int(nH)
    nF := nH - lH
    nP := nL * (1 - nS)
    nQ := nL * (1 - nS * nF)
    nT := nL * (1 - nS * (1 - nF))

    DO CASE
      CASE lH == 0
        R := nL * 255
        G := nT * 255
        B := nP * 255
      CASE lH == 1
        R := nQ * 255
        G := nL * 255
        B := nP * 255
      CASE lH == 2
        R := nP * 255
        G := nL * 255
        B := nT * 255
      CASE lH == 3
        R := nP * 255
        G := nQ * 255
        B := nL * 255
      CASE lH == 4
        R := nT * 255
        G := nP * 255
        B := nL * 255
      CASE lH == 5
        R := nL * 255
        G := nP * 255
        B := nQ * 255
    ENDCASE
  ELSE
    R := (L * 255) / 100
    G := R
    B := R
  ENDIF

RETURN {r,g,b}

//** convert from RGB Color to HSB (aRGB should be {RED,GREEN,BLUE})
FUNCTION RGBToHSB(aRGB)
  LOCAL nTemp, lMin, lMax, lDelta, R, G, B, H, S, L

  R := aRGB[1]
  G := aRGB[2]
  B := aRGB[3]

  lMax := IIf(R > G, IIf(R > B, R, B), IIf(G > B, G, B))
  lMin := IIf(R < G, IIf(R < B, R, B), IIf(G < B, G, B))

  lDelta := lMax - lMin

  L := (lMax * 100) / 255

  IF lMax > 0
    S := (lDelta / lMax) * 100

    IF lDelta > 0
      IF lMax == R
        nTemp := (G - B) / lDelta
      ELSEIF lMax == G
        nTemp := 2 + (B - R) / lDelta
      ELSE
        nTemp := 4 + (R - G) / lDelta
      ENDIF

      H := nTemp * 60

      IF H < 0
        H := H + 360
      ENDIF
    ENDIF
  ENDIF

RETURN {H,S,L}